/*

*/

/**
   A generic {@code Pair} class.
*/
public class Pair<T1, T2>
{
   private T1 first;
   private T2 second;







   /**
      Override the {@code equals()} method from the {@link Object} class.
      <p>
      Two {@code Pair} objects are equal if their first elements are
      equal and their second elements are equal.

      @param o  {@link Object} to compare this {@code Pair} object with
      @return true if the given object is a {@code Pair} object with
              first and second elements equal to this object's first
              and second elements, false otherwise
   */
   @Override
   public boolean equals(Object o)
   {
      if (o == null)
      {
         return false;
      }
      if (o == this)
      {
         return true;
      }
      if ( !(o instanceof Pair) )
      {
         return false;
      }
      return ( ((Pair)o).getFirst().equals(first)
            && ((Pair)o).getSecond().equals(second) );
   }

   /**
      Override the {@code hashCode()} method from the {@link Object} class.

      @return a simple hashcode value
   */
   @Override
   public int hashCode(){return first.hashCode() + 31*second.hashCode();}

}//Pair<T1, T2>
